import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Scanner;


public class Data {
private 
//int idData;
FileReader input_file;
PrintWriter output_file;
Istance i;


// ausiliar variable
int k=0, n=0;


public Data(String problem, PrintWriter pw, String dataID) throws Exception {
		// problem is the paht of inputfile and pw is the path of general outputfile
		input_file= new FileReader(problem);
		Scanner inFile= new Scanner(input_file);
		i =new Istance(dataID);
		int kcolor=0;
		output_file=pw;

	while (inFile.hasNextLine()){
		Scanner line = new Scanner(inFile.nextLine());
		if (line.hasNext("KCOLOR"))
		{line.next("KCOLOR");
			if (line.hasNextInt())
			kcolor=line.nextInt();
			else throw new Exception("specify int k for KCOLOR");
		}else if (line.hasNext("VARIABLE"))
		 {	line.next("VARIABLE");
			if (line.hasNextInt())
		 	{	
			 int id=line.nextInt();
			//find k for previus created istance
		 		if (line.hasNextInt())
		 		{	line.nextInt();
		 			if (line.hasNextInt())
		 				{k=line.nextInt();
		 				i.addNode(new Node(id,k));
		 				}
		 			else throw new Exception("specify int input for VARIABLE");
		 		}else if (kcolor>0)
		 			{k=kcolor;
		 			i.addNode(new Node(id,k));
		 			}
		 		else 	throw new Exception("specify positive int for k (number of colors)");
		 	}
		
		 	}else if (line.hasNext("CONSTRAINT"))
		     {line.next("CONSTRAINT");
		 		if (line.hasNextInt()){
		    	 int x1=line.nextInt();
		    	 if (line.hasNextInt())
		    		 {int x2=line.nextInt();
		    		 i.addConstraint(x1,x2);
		    		 }
		    	 else throw new Exception("error: specify int input for CONSTRAINTS");
		     }else throw new Exception("error: specify int input for CONSTRAINTS");
		     }else if (line.hasNext("SINGLECONSTRAINT")){
		    	 line.next("SINGLECONSTRAINT");
		    	 		if (line.hasNextInt())
		    	 		{int single_constr=line.nextInt();
			   	 				if (inFile.hasNextLine()){
			   	 					while (inFile.hasNext("NOGOOD")){
			   	 					Scanner data1=new Scanner(inFile.nextLine());
		    	 					if (data1.hasNext("NOGOOD"))
		    	 					{data1.next("NOGOOD");
		    	 						if (data1.hasNextInt()){
		    	 						int color=data1.nextInt();
		    	 						i.delete_domain(single_constr,color);
		    	 						
		    	 						}else throw new Exception("specify NOGOOD value");
						
		    	 					}else throw new Exception("add NOGOOD keyword");
				
			   	 					}//end_while
		    	 				}	
				
		    	 		}	
		

		
		     }
	}//end while
		



	System.out.println("istance " + dataID + " created with n " + i.n + " node.");
		
		
	

		
	}





public void showIstance(){

String out_conflict="";
for (int x=0; x<i.n; x++){
	
	for (int z=0; z<x; z++)
		if (i.getConflict(x,z))
		out_conflict= out_conflict + " x"+ z  + " != x" +  x + "\n";
}
output_file.println("Conflict: \n" +  out_conflict);
output_file.println("Domain:");
for (int x=0; x<i.n; x++){
	String domain="";
	for(int col=0; col<i.assignment.get(x).domain.size; col++)
		if (i.assignment.get(x).domain.dom[col]==true)
		domain= domain +" " + col;
	output_file.println("x" + x + " = (" + domain + " )" );
}

}





public void test() throws FileNotFoundException {
	// this method starts the algorithms
	
	//long time;
	long end,start;
	
	start = System.currentTimeMillis();
	//start=time;
	i.Backtracking();
	end=System.currentTimeMillis();
	//end=time;
	i.s.timeB=end-start;
	String res="";
	for (int s=0; s<i.n; s++)
		res=res+ " " + i.assignment.get(s).solution;
	i.s.solB="result" + res;

for (int s=0; s<i.n; s++)
	i.assignment.get(s).solution=-1;


	start = System.currentTimeMillis();
	//start=time;
	i.Gaschnig();
	end=System.currentTimeMillis();
	//end=time;
	i.s.timeG=end-start;
	 res="";
	for (int s=0; s<i.n; s++)
		res=res+ " " + i.assignment.get(s).solution;
	i.s.solG="result" + res;
	
	
	i.saveStatistic(output_file);
		

}







}
